/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define OLEN	256

class OptionList : public List
{
	private:
		int	maxTTL;
		int	defaultTTL;
		int	routingTableSize;
		int	maxConnections;
		int	maxResults;
		int	maxHops;
		int	maxPushRequests;
		int	maxUploads;
		int	maxDownloads;
		int	maxHosts;
		int	port;
		int	speed;
		int	monitorLength;
		int	autoPush;
		int	autoClearComplete;
		int	autoConnections;
		char	downloadDir[OLEN];
		int	daemonPort;
		
	public:
		OptionList(int mttl, int dttl, int rts, int mcon, int mres,
			int mhop, int mpr, int mu, int md, int mh, int p,
			int sp, int ml, int ap, int acc, int ac, char *dd,
			int dp);
			
		int	getMaxTTL();
		
		int	getDefaultTTL();
		
		int	getRoutingTableSize();
		
		int	getMaxConnections();
		
		int	getMaxResults();
		
		int	getMaxHops();
		
		int	getMaxPushRequests();
		
		int	getMaxUploads();
		
		int	getMaxDownloads();
		
		int	getMaxHosts();
		
		int	getPort();
		
		int	getSpeed();
		
		int	getMonitorLength();
		
		int	getAutoPush();
		
		int	getAutoClearComplete();
		
		int	getAutoConnections();
		
		void	getDownloadDir(char *buf);
		
		int	getDaemonPort();
};
