/***************************************************************************
 *                                                                         *
 *   This program is free software you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation either version 2 of the License, or      *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include "ControlCentre.h"
#include "DBElement.h"
#include "Buffer.h"
#include "GnutellaPacket.h"
#include "Connection.h"
#include "Host.h"
#include "Path.h"
#include "File.h"
#include "CacheEntry.h"

CacheEntry::CacheEntry(char *newPattern)
{
	memcpy(pattern, newPattern, FILE_NAME_LENGTH);
	response	= 0;
}

CacheEntry::CacheEntry(char *newPattern, GnutellaPacket *newResponse)
{
	memcpy(pattern, newPattern, FILE_NAME_LENGTH);
	response	= newResponse;
}

CacheEntry::~CacheEntry()
{
	if (response)
		delete response;
}

void CacheEntry::setResponse(GnutellaPacket *newResponse)
{
	if (response)
		delete response;

	response	= newResponse;
}

/*
 * FAME
 */
char *CacheEntry::getPatternp()
{
	return (char *)pattern;
}

GnutellaPacket *CacheEntry::getResponsep()
{
	return response;
}

/*
 * DBElement inheritance
 */
int CacheEntry::equals(DBElement *object)
{
	return (!strncmp(pattern, ((CacheEntry *)object)->getPatternp(),
				FILE_NAME_LENGTH));
}

int CacheEntry::lessThan(DBElement *object)
{
	return (strncmp(pattern, ((CacheEntry *)object)->getPatternp(),
				FILE_NAME_LENGTH) < 0);
}

int CacheEntry::greaterThan(DBElement *object)
{
	return (strncmp(pattern, ((CacheEntry *)object)->getPatternp(),
				FILE_NAME_LENGTH) > 0);
}

unsigned int CacheEntry::hashValue()
{
	return (*(unsigned int *)pattern & MAX_HASH);
}
