/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define DB_HASH_ARRAY_SIZE	(MAX_HASH + 1)

class DB
{
	private:
		DBElement		*myDBhash[DB_HASH_ARRAY_SIZE];
		DBElement		**myDB;
		int			DBSize;
		int			last;
		int			elements;
		DBElement		*mklist(DBElement *tree);
		void 			insertSortedList(DBElement *list,
						int len, int hash);
		void			insertSortedElement(DBElement *el,
						int hash);

	public:
		DB(int size);

		~DB();

		void 		clearDB();

		DBElement 	*findElement(int index);

		int 		containsElement(DBElement *el);

		int 		storeElement(DBElement *el);

		int 		deleteElement(int index);

		int		removeElement(int index);

		int 		isFull();

		int 		containsElementAtIndex(int i);

		int 		getSize();

		int 		getElements();

		int 		integrity();

		void		balance();
};
