/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * This Class is supposed to be abstract.
 */

#define	ENTRY_INVALID	-1
#define NO_PARENT	-1
#define PARENT_INVALID	-2
#define MAX_HASH	0x1FFFF
 
class DBElement
{
	protected:
		DBElement	*left;
		DBElement	*right;
		int		entry;
		int		parent;

	public:
		DBElement();

		DBElement(int newEntry, int newParent);

		DBElement 	*getLeft();

		DBElement 	*getRight();

		int 		getEntry();

		int 		getParent();

		void 		setLeft(DBElement *newLeft);

		void 		setRight(DBElement *newRight);

		void 		setEntry(int newEntry);

		void 		setParent(int newParent);

		/*
		 * These Functions should be overloaded
		 */

                virtual int 	equals(DBElement *object) = 0;

                virtual int 	lessThan(DBElement *object) = 0;

                virtual int 	greaterThan(DBElement *object) = 0;

		/*
		 * hashValue should alwyas generate the same value for
		 * given object! It's range should be 0 - (2^17 - 1)
		 * (== 128 * 1024 - 1 == 0x1FFFF)
		 */
		virtual unsigned int	hashValue() = 0;

		virtual ~DBElement() {};
};
