/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define DOTTED_LENGTH	25
 
class Host : public DBElement
{
	private	:
		char		clientID[CLIENTID_LENGTH];
		int		fileCount;
		int		fileSize;
		unsigned char	ip[4];
		unsigned long	netIP;
		unsigned short	port;
		int		real;
		int		tries;

	public:
		Host();

		Host(unsigned char a, unsigned char b, unsigned char c, unsigned char d,
				unsigned short newPort);
		Host(unsigned char a, unsigned char b, unsigned char c, unsigned char d,
				unsigned short newPort, char *cid);

		Host(unsigned char a, unsigned char b, unsigned char c, unsigned char d,
				unsigned short newPort,int fc, int fs);

		Host(unsigned long newNetIP, unsigned short newPort);

		Host(unsigned long newNetIP, unsigned short newPort, char *cid);

		Host(unsigned long newNetIP, unsigned short newPort, int fc, int fs);

		Host(unsigned long newNetIP, unsigned short newPort, char *cid, int fc, int fs);

		Host(char *dotted);

		Host(char *dotted, int fc, int fs);

		Host(char *dotted, char *cid);

		~Host();

		int		getFileSize();

		int		getFileCount();

		unsigned char	getIP(int i);

		unsigned long	getNetIP();

		unsigned short	getPort();

		int		isReal();

		void		setReal(int nr);

		void		incTries();
		
		int		getTries();
		
		void		setTries(int t);

		Connection	*HConnect();

		void		getDotted(char *buf);
		
		int		hasClientID();

		void		getClientID(char *buf);

		void		setClientID(char *buf);

		/*
		 * FAME
		 */

		char		*getClientIDp();

		/*
		 * DBElelement inheritance
		 */

		int 		equals(DBElement *myHost);

		int 		lessThan(DBElement *myHost);

		int 		greaterThan(DBElement *myHost);

		unsigned int 	hashValue();
};
