/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#include <stdio.h>
#include <string.h>
#include "ControlCentre.h"
#include "DBElement.h"
#include "GnutellaPacket.h"
#include "Mesg.h"

Mesg::Mesg()
{
	connection	= -1;
	func		= FUNC_INVALID;
}

Mesg::Mesg(GnutellaPacket *pkt)
{
	connection	= pkt->getConnection();
	func		= pkt->getType();
	pkt->getMesgID((unsigned char *)mesgID);
}

Mesg::Mesg(int newConnection, char newFunc, char *newMesgID)
{
	connection	= newConnection;
	func		= newFunc;
	memcpy(mesgID, newMesgID, MESSAGE_ID_LENGTH);
}

Mesg::~Mesg()
{
}

int Mesg::getConnection()
{
	return connection;
}

char Mesg::getFunc()
{
	return func;
}

void Mesg::getMesgID(char *buf)
{
	memcpy(buf, mesgID, MESSAGE_ID_LENGTH);
}

void Mesg::setConnection(int newConnection)
{
	connection	= newConnection;
}

void Mesg::setFunc(char newFunc)
{
	func	= newFunc;
}

void Mesg::setMesgID(char *src)
{
	memcpy(mesgID, src, MESSAGE_ID_LENGTH);
}

/*
 * DBElement Inheritance
 */

int Mesg::equals(DBElement *myMesg)
{
	return (!strncmp(mesgID, ((Mesg *)myMesg)->getMesgIDp(), MESSAGE_ID_LENGTH));
}

int Mesg::lessThan(DBElement *myMesg)
{
	return (strncmp(mesgID, ((Mesg *)myMesg)->getMesgIDp(), MESSAGE_ID_LENGTH) < 0);
}

int Mesg::greaterThan(DBElement *myMesg)
{
	return (strncmp(mesgID, ((Mesg *)myMesg)->getMesgIDp(), MESSAGE_ID_LENGTH) > 0);
}

unsigned int Mesg::hashValue()
{
	return (*(unsigned int *)mesgID + 4) & MAX_HASH;
}

/*
 * FAME
 */

char *Mesg::getMesgIDp()
{
	return (char *)mesgID;
}

