#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <time.h>
#include "ControlCentre.h"
#include "Config.h"
#include "DBElement.h"
#include "Buffer.h"
#include "GnutellaPacket.h"
#include "Connection.h"
#include "Transfer.h"

Transfer::Transfer()
{
	fileID		= -1;
	file		=  0;
	fileName[0]	=  0;
	offset		=  0;
	bytesLeft	=  0;
	bytesTotal	=  0;
	bytesDone	=  0;
}

Transfer::Transfer(int newFileID, char *newFileName, char *newDirName,
			int newOffset, Connection *c)
	: Connection(c)
{
	file		=  0;
	fileID		= newFileID;
	offset		= newOffset;
	strncpy(fileName, newFileName, TRANSFER_FN_LENGTH - 2);
	fileName[TRANSFER_FN_LENGTH - 1]	= 0;
	strncpy(dirName, newDirName, TRANSFER_FN_LENGTH - 2);
	dirName[TRANSFER_FN_LENGTH - 1]	= 0;
	bytesDone	= 0;
	bytesLeft	= 0;
	bytesTotal	= 0;
}

Transfer::Transfer(int newFileID, char *newFileName, char *newDirName,
			int newOffset, int newSock, 
			struct sockaddr_in newsa)
	: Connection(newSock, newsa)
{
	file		=  0;
	fileID		= newFileID;
	offset		= newOffset;
	strncpy(fileName, newFileName, TRANSFER_FN_LENGTH - 2);
	fileName[TRANSFER_FN_LENGTH - 1]	= 0;
	strncpy(dirName, newDirName, TRANSFER_FN_LENGTH - 2);
	dirName[TRANSFER_FN_LENGTH - 1]	= 0;
	bytesLeft	= 0;
	bytesTotal	= 0;
	bytesDone	= 0;
}

Transfer::~Transfer()
{
	if (file)
		fclose(file);
	closeConnection();
}

int Transfer::Start(int ro)
{
	char	fn[2 * TRANSFER_FN_LENGTH];

	sprintf(fn, "%s/%s", dirName, fileName);
	if (ro)
	{
		if (!(file = fopen(fn, "r")))
		{
			fprintf(stderr, "Error : Can't open file >%s<.\n",
					fn);
			return 0;
		}

	}
	else
	{
		file	= 0;
		if (offset > 0)
			file = fopen(fn, "r+");

		if (!file)
			if (!(file = fopen(fn, "w+")))
			{
				fprintf(stderr, 
					"Error : Can't open file >%s<.\n",
						fn);
				return 0;
			}
	}

	if (offset >= 0)
		if (fseek(file, offset, SEEK_SET))
		{
			fprintf(stderr, "Error : Seek failed");
			fclose(file);
			return 0;
		}

	return 1;
}

int Transfer::getFileID()
{
	return fileID;
}

int Transfer::getOffset()
{
	return offset;
}

void Transfer::getFileName(char *buf)
{
	strncpy(buf, fileName, TRANSFER_FN_LENGTH - 2);
	buf[TRANSFER_FN_LENGTH - 1]	= 0;
}

int Transfer::getBytesLeft()
{
	return bytesLeft;
}

int Transfer::getBytesDone()
{
	return bytesDone;
}

int Transfer::getBytesTotal()
{
	return bytesTotal;
}

/*
 * FAME
 */

char *Transfer::getFileNamep()
{
	return (char *)fileName;
}

char *Transfer::getDirNamep()
{
	return (char *)dirName;
}

