#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include "Config.h"
#include "ControlCentre.h"
#include "DBElement.h"
#include "Buffer.h"
#include "GnutellaPacket.h"
#include "Connection.h"
#include "Host.h"
#include "Path.h"
#include "File.h"
#include "Transfer.h"
#include "TransferStatus.h"

TransferStatus::TransferStatus()
{
	next	= 0;
}

TransferStatus::TransferStatus(Transfer *t)
{
	unsigned int		len;
	struct sockaddr_in	sa;

	next            = 0;
	bytesDone	= t->getBytesDone();
	bytesLeft	= t->getBytesLeft();
	bytesTotal	= t->getBytesTotal();
	fileIndex	= t->getFileID();
	transferID	= t->getEntry();
	state		= t->getState();
	stamp		= t->getTimeStamp();
	stampNow	= time(0);
	t->getFileName(fileName);
	len	= sizeof(sa);
	getpeername(t->getConnection(), (struct sockaddr *)&sa, &len);
	sprintf(peerDotted, "%s:%u", inet_ntoa(sa.sin_addr),
			sa.sin_port);
}

int TransferStatus::getState()
{
	return state;
}

time_t TransferStatus::getStamp()
{
	return stamp;
}

time_t TransferStatus::getStampNow()
{
	return stampNow;
}

int TransferStatus::getTransferID()
{
	return transferID;
}

int TransferStatus::getBytesDone()
{
	return bytesDone;
}

int TransferStatus::getBytesLeft()
{
	return bytesLeft;
}

int TransferStatus::getBytesTotal()
{
	return bytesTotal;
}

int TransferStatus::getFileIndex()
{
	return fileIndex;
}

TransferStatus *TransferStatus::getNext()
{
	return next;
}

void TransferStatus::getPeerDotted(char *buf)
{
	strncpy(buf, peerDotted, DOTTED_LENGTH - 2);
	buf[DOTTED_LENGTH - 1]		= 0;
}

void TransferStatus::getFileName(char *buf)
{
	strncpy(buf, fileName, FILE_NAME_LENGTH - 2);
	buf[FILE_NAME_LENGTH - 1]	= 0;
}

void TransferStatus::setNext(TransferStatus *newNext)
{
	next 	= newNext;
}

/*
 * FAME
 */

char *TransferStatus::getPeerDottedp()
{
	return (char *)peerDotted;
}

char *TransferStatus::getFileNamep()
{
	return (char *)fileName;
}
